/**
 * Created by wdzxc on 2016/5/7.
 */
var express = require('express');
var router = express.Router();
var path = require('path');
var util = require('util');
var fs = require('fs');

// 跨域支持
// router.use(function (req, res, next) {
//     console.log('---------------------\trouter\t' + req.method + '\t----------------------');
//     console.log('host : ' + req.headers.host);
//     console.log('href : ' + req._parsedUrl.href);
//     console.log('method : ' + req.method);
//     console.log('query : ' + Object.keys(req.query).map(name => name + "=" + req.query[name]).join(","));
//     next();
// });

// read json file
function readJson(path) {
    return new Promise((resolve) => {
        fs.readFile(path, "utf-8", (err, data) => {
            if (err) throw err;
            try {
                resolve(JSON.parse(data));
            } catch (msg) {
                resolve(msg);
            }
        });
    });
}

// get character
router.get('/wdzxc', async function (req, res) {

    try {
        let characterInfo = (await readJson(path.resolve(__dirname, "../data/characters.json")));
        let list = characterInfo.members;
        let name = req.query.name;
        req.query.callbck = req.query.callbck || req.query.jsonpCallback;
        res.jsonp({
            success: true,
            data: list.filter(e => e.name.indexOf(name || "") >= 0)
        });
    } catch (msg) {
        res.jsonp({
            success: false,
            msg: msg.message
        });
    }
});

// get character
router.get('/error', async function (req, res) {
    res.jsonp({
        success: false,
        msg: "just a error"
    });
});

// post
router.post('/wdzxc', function (req, res, next) {
    var arr = [];
    req.on("data", function (data) {
        arr.push(data);
    });
    req.on("end", function () {
        var data = Buffer.concat(arr).toString(), ret;
        try {
            ret = JSON.parse(data);
        } catch (err) {
        }
        req.body = ret;
        res.json({
            success: true,
            data: ret,
        });
        next();
    });
});

// get character
router.get('/test', async function (req, res) {

    var delay = 500;
    if(req.query.p==1){
        delay = 1000;
    }
    if(req.query.p==2){
        delay = 1500;
    }
    if(req.query.p==3){
        delay = 500;
    }

    setTimeout(() => {
        if(req.query.fail){
            res.jsonp({
                success: false,
                data: {
                    query: req.query
                }
            });
            return;
        }
        res.jsonp({
            success: true,
            data: {
                query: req.query
            }
        });
    // }, delay);
    }, 500 + Math.random()*1500);

});


module.exports = router;