var express = require('express');
var router = express.Router();
var multiparty = require('multiparty');
var util = require('util');
var fs = require('fs');

// 跨域支持
router.use(function (req, res, next) {
    res.header('Access-Control-Allow-Origin', '*');
    res.header('Access-Control-Allow-Headers', 'Content-Type, Content-Length, Authorization, Accept, X-Requested-With , yourHeaderFeild');
    res.header('Access-Control-Allow-Methods', 'PUT, POST, GET, DELETE, OPTIONS');
    if (req.method == 'OPTIONS') {
        res.send(200);
    } else {
        next();
    }
});

// 上传页面
router.get('/', function (req, res) {
    res.send('Upload need post method!');
});

// 上传
router.post('/', function (req, res) {
    // 生成multiparty对象，并配置上传目标路径
    var form = new multiparty.Form({
        uploadDir: './upload/'
    });
    // 上传完成后处理
    form.parse(req, function (err, fields, files) {
        var filesTmp = JSON.stringify(files, null, 2);
        if (err) {
            console.log('parse error: ' + err);
        } else {
            console.log('parse files: ' + filesTmp);
            var inputFile = files.files[0];
            var uploadedPath = inputFile.path;
            var dstPath = './upload/' + inputFile.originalFilename;
            // 重命名为真实文件名
            fs.rename(uploadedPath, dstPath, function(err) {
            	if (err) {
            		console.log('rename error: ' + err);
            	} else {
            		console.log('rename ok');
            	}
            });
        }
        res.json({
            success: true,
            path: 'http://localhost:3000/res/' + uploadedPath
        });
    });
});

module.exports = router;