## Description
对话框


## Usage
### Dialog
```js
// dailog > alert
$Dialog.alert("Tip: A alert box",functon(){
    console.log("click confirm btn");
});

// dailog > confirm
$Dialog.confirm("Tip: A confirm box",functon(){
    console.log("click confirm btn");
});

// dailog > notify
$Dialog.confirm("Show a notify!",2,2500);

// dailog > registerModal
$Dialog.registerModal({
    submitSuccess:{
        target:'#submitSuccessModal',
        transMtd:'Z-modal_show'
    },
    submitFail:{
        target:'#submitFailModal',
        transMtd:'Z-modal_show'
    }
});
$Dialog.submitSuccess('show',{tip:"提交成功！"});
$Dialog.submitSuccess('hide');

```

### $Dialog.alert
提示对话框
#### 参数
* param str {string} 提示字符串
* param callback {function} 点击确认按钮会触发的回调函数，默认不触发

### $Dialog.confirm
确认对话框
#### 参数
* param str {string} 提示字符串
* param callback {function} 点击确认按钮会触发的回调函数，默认不触发
* param callback {function} 点击取消按钮会触发的回调函数，默认不触发

### $Dialog.notify
通知对话框
#### 参数
* param str {string} 提示字符串
* param duration {number} 通知显示时间，默认为2000ms
* param icon {string} 左侧的图标，需要引用字体文件，具体参考代码...

### $Dialog.registerModal
注册模态框
#### 参数
* param str {object} 注册参数
```
{
    submitSuccess:{
        // {string|element} 模态框的选择方法或者元素本身
        target:'#submitSuccessModal',   
        // 可选参数，如果有这个参数则：
        // 在显示时给模态框元素附加这个参数值class
        // 在隐藏时在模态框元素移除这个参数值class
        transMtd:'Z-modal_show'
    },
    submitFail:{
        target:'#submitFailModal',
        transMtd:'Z-modal_show'
    }
}
```
#### 注册模态框后使用方法
```
$Dialog["name"]("show",renderData);
$Dialog["name"]("hide");
```
> renderData 会作为数据来渲染模态框的内容data-name,具体参考渲染文档


### wdLoading
Loading模块主要的功能就是为各种形式的载入过程提供一个可以简单操作的视图过程。

### $Loading.pageShow & $Loading.pageHide
直接替换页面显示内容的loading展示类型，主要用于页面初次加载、换页之类的场景。  
```js

// loading > page
$Loading.pageShow();
$Loading.pageHide();

```
### $Loading.coverShow & $Loading.coverHide
覆盖型的Loading，在当前页面显示一个半透明的遮罩层，在展示过程对阻止对覆盖界面的各种操作，不过对于移动端的一些浏览器，事件控制不太完善，需要根据具体情况进行一些处理。  
```js

// loading > cover
// 针对传入的字符串，会以一个列表的形式显示在Loading动画图标的下面
$Loading.coverShow('购物车加载中');
 // 如果隐藏方法依然传入了同一个字符串，很高的概率会在有多个显示内容的列表中隐藏对应内容的一条。→_→ 不是100%哦
$Loading.coverHide('购物车加载中');

```

### $Loading.insertShow & $Loading.insertHide
插入行的Loading，主要用于列表加载之类的情景，会自动附加在传入容器元素的末尾。  
```js
// loading > inset
var containerElem = document.body;
$Loading.insetShow(containerElem);
$Loading.insetHide(containerElem);

```


## Authors
- [wdzxc](http://git.oschina.net/wdzxc)
