/**
 * Created by wdzxc on 2017/4/20.
 */
import {$wd, $Dialog, $Loading, InterfaceProxy} from '../src/index.js';
import $ from 'jquery';
import axios from 'axios';

window.$ = $;
window.$wd = $wd;

// --- InterfaceProxy ---
let interfaceOpt = {
    jsonpRequest: {
        dataType: "jsonp",
        jsonp: "callback",
    },
    getOrderList: {
        returns: [{
            id: null,
            owner: null,
            products: function () {
                return "getOrderProducts"
            }
        }]
    },
    getJsonTest: {
        pathname: "/json/test",
        dataType: "jsonp",
        jsonp: "callback",
        paramsFilter: function (data) {
            data.p = 998;
            return data;
        }
    },
    getJsonTestMixin1: {
        mixins: "getJsonTest",
        loading: false
    },
    getJsonTestMixin2: {
        mixins: ["jsonpRequest", "getJsonTestMixin1"],
        loading: false,
        merge: false,
    },
    jsonError: {
        pathname: '/json/error',
        errCallback(msg) {
            console.log('default', msg);
        }
    },
};

// 接口初始化
window.iProxy = new InterfaceProxy(interfaceOpt, {
    callback(data) {
        console.log(data);
    },
    errCallback: function (msg) {
        console.log("opt fail", msg);
    },
    dataFilter: function (data) {
        return data;
    },
    params: {
        aaa: 998
    },
});

// iProxy.getJsonTest(()=>{
//     console.log('callback');
// }).then(()=>{
//     console.log('then-1');
// }).then(()=>{
//     console.log('then-2');
// });

iProxy.jsonError(() => {
    console.log('callback');
}).catch(() => {
    console.log('catch-1');
    return true;
}).catch(() => {
    console.log('catch-2');
    return true;
});

// $.ajax({
//     url: '/json/test',
//     type: 'get',
//     // contentType: "application/json; charset=utf-8",
//     // processData:false,
//     data: {
//         a: 998,
//         b: 999,
//     },
// });

// axios({
//     url: '/json/test',
//     method: 'get',
//     params: {
//         a: 998,
//         b: 999,
//     },
//     data: {
//         a: 998,
//         b: 999,
//     }
// }).then(data => {
//     console.log(data);
// });

let promise = new Promise(function (resolve, reject) {
    setTimeout(() => {
        reject('error');
    }, 500);
});

promise.catch(e => {
    console.log(e);
}).catch(e => {
    console.log(e);
});